__copyright__ = "Copyright (c) 2010 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import app.preprocessor
import os

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Create Binary Initialisation script"

    def createRuntime(self):
        distributionDir = self.cfg['DISTRIBUTION_DIR']
        binaryAppBin = os.path.join(self.cfg['BINARY_APP_DIR'], 'bin')
        tmplRubyEnv = os.path.join(distributionDir, 'code-templates', 
             'integrations', 'rubyenv.tmpl')
        rubyEnvScript = os.path.join(binaryAppBin,
             'rubyenv')
        tokenProcessor = app.util.getTokenProcessor(self.cfg)
        tokenProcessor.copyWithSubstitution(tmplRubyEnv, rubyEnvScript)
        app.util.runSystem("chmod 755 %s " % rubyEnvScript, self.log)

