__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseCreateRuntimeScript
import app.util
import service.util
import service.constants
import os
import commands
import sys

class CreateRuntimeScript(BaseCreateRuntimeScript):

    scriptDescription = "Migrating Binary DB"

    def createRuntime(self):

        appName = service.constants.APPLICATION_BINARY
        if not(service.util.isApplicationEnabledLocally(appName)):
           return

        #self.migrateBinaryApp()

        return

    def migrateBinaryApp(self):
        serviceName = service.constants.SERVICE_BINARY
        pgsqlServiceName = service.constants.SERVICE_PGSQL
        if (service.util.isServiceEnabledLocally(serviceName) 
            and not service.util.isServiceEnabledLocally(pgsqlServiceName)):
           dbHost = 'localhost'
        else:
           dbHost = self.cfg['DATABASE_HOST']

        cmd = "export PATH=%s/vendor/bundle/ruby/2.1.0/bin:%s/../ruby/bin/:$PATH ; " %(self.cfg['BINARY_APP_DIR'], self.cfg['SITE_DIR'])
        cmd += "export GEM_HOME=%s/vendor/bundle/ruby/2.1.0/ ; " % ( self.cfg['BINARY_APP_DIR'])
        cmd += "cd %s && CTF_BASE_URL=%s IAF_DBHOST=%s " % (self.cfg['BINARY_APP_DIR'], self.cfg['API_SOAP'], dbHost )
        cmd += "IAF_DBNAME=%s IAF_DBUSER=%s IAF_DBPASS='%s' " % (self.cfg['IAF_DBNAME'],self.cfg['IAF_DBUSER'],self.cfg['IAF_DBPASS'] )
        cmd += "RAILS_ENV=production ./bin/rake db:migrate" 
        

        self.logMesg("debug", "rake cmd: %s" %  cmd)
        migrateOutput = app.util.executeCommand(cmd)
        self.logMesg("debug", "Migrate output: %s" %  migrateOutput)
