__copyright__ = "Copyright (c) 2014 CollabNet, Inc. All rights reserved."

import os.path
from glob import glob


from app.scripts import BasePostInstallScript
import app.util
import commands

class PostInstallScript(BasePostInstallScript):

    scriptDescription = "Cleanup Old Remnant collabnet-binary-* directories"

    def isApplicable(self):
        lookUpDir = os.path.dirname(self.cfg['BINARY_APP_DIR'])
        self.collabBinDirs = [directory for directory in glob("%s/collabnet-binary-*" %lookUpDir) if directory != self.cfg['BINARY_APP_DIR']]
        if self.collabBinDirs:
            return True
        
        return False

    def postInstall(self):
        for directory in self.collabBinDirs:
            baseDir, binDir = os.path.split(directory)
            self.logMesg('debug', "Moving directory: %s" %directory)
            cmd = "mv %s %s/.%s-DELETE-ME" %(directory, baseDir, binDir)
            (retVal, outputVal) = commands.getstatusoutput(cmd)
            if (retVal != 0 ):
                self.addError("Error: [%s]"%outputVal)
                raise Exception("RunCommandException")

            self.logMesg('debug', outputVal)

        return

