__copyright__ = "Copyright (c) 2007 CollabNet, Inc. All rights reserved."

from app.scripts import BaseOptionScript
import os
import service.util
import service.constants
import service.exception
import app.tokens.generations
import app.util

class OptionScript(BaseOptionScript):

    def optionSnippet(self):

        nodeHost      = service.util.getLocalNodeHostName()
        # If Binary is enabled locally?
        if (service.util.isApplicationEnabled(service.constants.APPLICATION_BINARY, nodeHost)):
             # Default Binary config parameters.
             tokenGenerations = app.tokens.generations.TokenGenerations()
             binaryAppDir = app.util.executeCommand("dirname `rpm -ql cn-binary | grep -v vendor| grep -E '\.bundle$'`")
             serviceName = service.constants.SERVICE_BINARY
             pgsqlServiceName = service.constants.SERVICE_PGSQL

             dbHost = 'localhost'
             binaryHost = service.util.getHostDomain(service.util.getApplicationHost(service.constants.APPLICATION_BINARY))
             # Initialize the service command based on platform
             if "redhat-7" in self.cfg["PLATFORM"]:
                 serviceCommand = "/opt/collabnet/teamforge/runtime/scripts/tfsystemd binary"
             else:
                 serviceCommand = "/etc/init.d/binary"

             binaryServiceCommand = serviceCommand
             
             return "\n".join(["IAF_DBNAME=%s\n" % "iafdb",
                               "IAF_DBUSER=%s\n" % "iafdbusr",
                               "IAF_DBPASS=%s\n" % "$auto$",
                               "IAF_DBHOST=%s\n" % dbHost,
                               "BINARY_LISTEN_PORT=%s\n" % "8500",
                               "BINARY_SERVICE_CMD=%s\n" % binaryServiceCommand,
                               "BINARY_SETUP_TYPE=%s\n" % "ALL",
                               "BINARY_APP_USER=%s\n" % "root",
                               "CTF_BASE_DIR=%s\n" % os.path.normpath(os.path.join(self.cfg['SITE_DIR'],'..')),
                               "BINARY_APP_DIR=%s\n" % binaryAppDir,
                               "BINARY_HOST=%s\n" % binaryHost,
                               "BINARY_LOG_DIR=%s\n" % os.path.join(self.cfg['LOG_DIR'], "iaf/")])
        else:
             return ""
